diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index ad5cd41..40f7671 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -210,11 +210,13 @@ static const char *const subdirs[] = {
 	"pg_snapshots",
 	"pg_subtrans",
 	"pg_twophase",
+	"pg_undo",
 	"pg_multixact",
 	"pg_multixact/members",
 	"pg_multixact/offsets",
 	"base",
 	"base/1",
+	"base/undo",
 	"pg_replslot",
 	"pg_tblspc",
 	"pg_stat",
diff --git a/src/bin/pg_checksums/pg_checksums.c b/src/bin/pg_checksums/pg_checksums.c
index b8e7c32..825b11c 100644
--- a/src/bin/pg_checksums/pg_checksums.c
+++ b/src/bin/pg_checksums/pg_checksums.c
@@ -167,7 +167,7 @@ skipfile(const char *fn)
 }
 
 static void
-scan_file(const char *fn, BlockNumber segmentno)
+scan_file(const char *fn, BlockNumber first_blkno)
 {
 	PGAlignedBlock buf;
 	PageHeader	header = (PageHeader) buf.data;
@@ -208,7 +208,7 @@ scan_file(const char *fn, BlockNumber segmentno)
 		if (PageIsNew(header))
 			continue;
 
-		csum = pg_checksum_page(buf.data, blockno + segmentno * RELSEG_SIZE);
+		csum = pg_checksum_page(buf.data, blockno + first_blkno);
 		current_size += r;
 		if (mode == PG_MODE_CHECK)
 		{
@@ -310,7 +310,7 @@ scan_directory(const char *basedir, const char *subdir, bool sizeonly)
 			char		fnonly[MAXPGPATH];
 			char	   *forkpath,
 					   *segmentpath;
-			BlockNumber segmentno = 0;
+			BlockNumber first_blkno;
 
 			if (skipfile(de->d_name))
 				continue;
@@ -325,15 +325,22 @@ scan_directory(const char *basedir, const char *subdir, bool sizeonly)
 			segmentpath = strchr(fnonly, '.');
 			if (segmentpath != NULL)
 			{
+				char	   *end;
+
 				*segmentpath++ = '\0';
-				segmentno = atoi(segmentpath);
-				if (segmentno == 0)
+				if (strstr(segmentpath, "undo"))
+					first_blkno = strtol(segmentpath, &end, 16) / BLCKSZ;
+				else
+					first_blkno = strtol(segmentpath, &end, 10) * RELSEG_SIZE;
+				if (*end != '\0')
 				{
-					pg_log_error("invalid segment number %d in file name \"%s\"",
-								 segmentno, fn);
+					pg_log_error("invalid segment number in file name \"%s\"",
+								 fn);
 					exit(1);
 				}
 			}
+			else
+				first_blkno = 0;
 
 			forkpath = strchr(fnonly, '_');
 			if (forkpath != NULL)
@@ -350,7 +357,7 @@ scan_directory(const char *basedir, const char *subdir, bool sizeonly)
 			 * the items in the data folder.
 			 */
 			if (!sizeonly)
-				scan_file(fn, segmentno);
+				scan_file(fn, first_blkno);
 		}
 #ifndef WIN32
 		else if (S_ISDIR(st.st_mode) || S_ISLNK(st.st_mode))
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index 2734f87..1580380 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -80,6 +80,7 @@ static bool ReadControlFile(void);
 static void GuessControlValues(void);
 static void PrintControlValues(bool guessed);
 static void PrintNewControlValues(void);
+static void AdjustRedoLocation(const char *DataDir);
 static void RewriteControlFile(void);
 static void FindEndOfXLOG(void);
 static void KillExistingXLOG(void);
@@ -510,6 +511,7 @@ main(int argc, char *argv[])
 	/*
 	 * Else, do the dirty deed.
 	 */
+	AdjustRedoLocation(DataDir);
 	RewriteControlFile();
 	KillExistingXLOG();
 	KillExistingArchiveStatus();
@@ -899,6 +901,82 @@ PrintNewControlValues(void)
 
 
 /*
+ * Compute the new redo, and move the pg_undo file to match if necessary.
+ * Rather than renaming it, we'll create a new copy, so that a failure that
+ * occurs before the controlfile is rewritten won't be fatal.
+ */
+static void
+AdjustRedoLocation(const char *DataDir)
+{
+	uint64		old_redo = ControlFile.checkPointCopy.redo;
+	char		old_pg_undo_path[MAXPGPATH];
+	char		new_pg_undo_path[MAXPGPATH];
+	int			old_fd;
+	int			new_fd;
+	ssize_t		nread;
+	ssize_t		nwritten;
+	char		buffer[1024];
+
+	/*
+	 * Adjust fields as needed to force an empty XLOG starting at
+	 * newXlogSegNo.
+	 */
+	XLogSegNoOffsetToRecPtr(newXlogSegNo, SizeOfXLogLongPHD, WalSegSz,
+							ControlFile.checkPointCopy.redo);
+
+	/* If the redo location didn't move, we don't need to do anything. */
+	if (old_redo == ControlFile.checkPointCopy.redo)
+		return;
+
+	/*
+	 * Otherwise we copy the pg_undo file, because its name must match the redo
+	 * location.
+	 */
+	snprintf(old_pg_undo_path,
+			 sizeof(old_pg_undo_path),
+			 "%s/pg_undo/%016" INT64_MODIFIER "X",
+			 DataDir,
+			 old_redo);
+	snprintf(new_pg_undo_path,
+			 sizeof(new_pg_undo_path),
+			 "%s/pg_undo/%016" INT64_MODIFIER "X",
+			 DataDir,
+			 ControlFile.checkPointCopy.redo);
+	old_fd = open(old_pg_undo_path, O_RDONLY, 0);
+	if (old_fd < 0)
+	{
+		pg_log_error("could not open \"%s\": %m", old_pg_undo_path);
+		exit(1);
+	}
+	new_fd = open(new_pg_undo_path, O_RDWR | O_CREAT, 0644);
+	if (new_fd < 0)
+	{
+		pg_log_error("could not open \"%s\": %m", old_pg_undo_path);
+		exit(1);
+	}
+	while ((nread = read(old_fd, buffer, sizeof(buffer))) > 0)
+	{
+		do
+		{
+			nwritten = write(new_fd, buffer, nread);
+			if (nwritten < 0)
+			{
+				pg_log_error("could not write to \"%s\": %m", new_pg_undo_path);
+				exit(1);
+			}
+			nread -= nwritten;
+		} while (nread > 0);
+	}
+	if (nread < 0)
+	{
+		pg_log_error("could not read from \"%s\": %m", old_pg_undo_path);
+		exit(1);
+	}
+	close(old_fd);
+	close(new_fd);
+}
+
+/*
  * Write out the new pg_control file.
  */
 static void
diff --git a/src/bin/pg_upgrade/Makefile b/src/bin/pg_upgrade/Makefile
index 2cb829a..82c8033 100644
--- a/src/bin/pg_upgrade/Makefile
+++ b/src/bin/pg_upgrade/Makefile
@@ -9,7 +9,7 @@ include $(top_builddir)/src/Makefile.global
 
 OBJS = check.o controldata.o dump.o exec.o file.o function.o info.o \
        option.o parallel.o pg_upgrade.o relfilenode.o server.o \
-       tablespace.o util.o version.o $(WIN32RES)
+       tablespace.o undo.o util.o version.o $(WIN32RES)
 
 override CPPFLAGS := -DDLSUFFIX=\"$(DLSUFFIX)\" -I$(srcdir) -I$(libpq_srcdir) $(CPPFLAGS)
 LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport)
diff --git a/src/bin/pg_upgrade/check.c b/src/bin/pg_upgrade/check.c
index 617270f..02e94a0 100644
--- a/src/bin/pg_upgrade/check.c
+++ b/src/bin/pg_upgrade/check.c
@@ -21,6 +21,7 @@ static void check_locale_and_encoding(DbInfo *olddb, DbInfo *newdb);
 static bool equivalent_locale(int category, const char *loca, const char *locb);
 static void check_is_install_user(ClusterInfo *cluster);
 static void check_proper_datallowconn(ClusterInfo *cluster);
+static void check_for_undo_data(ClusterInfo *cluster);
 static void check_for_prepared_transactions(ClusterInfo *cluster);
 static void check_for_isn_and_int8_passing_mismatch(ClusterInfo *cluster);
 static void check_for_tables_with_oids(ClusterInfo *cluster);
@@ -97,6 +98,7 @@ check_and_dump_old_cluster(bool live_check)
 	 */
 	check_is_install_user(&old_cluster);
 	check_proper_datallowconn(&old_cluster);
+	check_for_undo_data(&old_cluster);
 	check_for_prepared_transactions(&old_cluster);
 	check_for_reg_data_type_usage(&old_cluster);
 	check_for_isn_and_int8_passing_mismatch(&old_cluster);
@@ -171,6 +173,7 @@ check_new_cluster(void)
 
 	check_is_install_user(&new_cluster);
 
+	check_for_undo_data(&new_cluster);
 	check_for_prepared_transactions(&new_cluster);
 }
 
@@ -801,6 +804,45 @@ check_for_prepared_transactions(ClusterInfo *cluster)
 
 
 /*
+ *	check_for_live_undo_data()
+ *
+ *	Make sure there are no live undo records (aborted transactions that have
+ *	not been rolled back, or committed transactions whose undo data has not
+ *	yet been discarded).
+ */
+static void
+check_for_undo_data(ClusterInfo *cluster)
+{
+	PGresult   *res;
+	PGconn	   *conn = connectToServer(cluster, "template1");
+
+	if (GET_MAJOR_VERSION(old_cluster.major_version) < 1200)
+		return;
+
+	prep_status("Checking for undo data");
+
+	res = executeQueryOrDie(conn,
+							"SELECT * "
+							"FROM pg_catalog.pg_stat_undo_logs "
+							"WHERE discard != insert");
+
+	if (PQntuples(res) != 0)
+	{
+		if (cluster == &old_cluster)
+			pg_fatal("The source cluster contains live undo data\n");
+		else
+			pg_fatal("The target cluster contains live undo data\n");
+	}
+
+	PQclear(res);
+
+	PQfinish(conn);
+
+	check_ok();
+}
+
+
+/*
  *	check_for_isn_and_int8_passing_mismatch()
  *
  *	contrib/isn relies on data type int8, and in 8.4 int8 can now be passed
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
index 3823641..523e86e 100644
--- a/src/bin/pg_upgrade/controldata.c
+++ b/src/bin/pg_upgrade/controldata.c
@@ -59,6 +59,7 @@ get_control_data(ClusterInfo *cluster, bool live_check)
 	bool		got_date_is_int = false;
 	bool		got_data_checksum_version = false;
 	bool		got_cluster_state = false;
+	bool		got_redo_location = false;
 	char	   *lc_collate = NULL;
 	char	   *lc_ctype = NULL;
 	char	   *lc_monetary = NULL;
@@ -485,6 +486,23 @@ get_control_data(ClusterInfo *cluster, bool live_check)
 			cluster->controldata.data_checksum_version = str2uint(p);
 			got_data_checksum_version = true;
 		}
+		else if ((p = strstr(bufin, "Latest checkpoint's REDO location:")) != NULL)
+		{
+			uint32		hi;
+			uint32		lo;
+
+			p = strchr(p, ':');
+
+			if (p == NULL || strlen(p) <= 1)
+				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
+
+			p++;				/* remove ':' char */
+
+			if (sscanf(p, "%X/%X", &hi, &lo) != 2)
+				pg_fatal("%d: controldata cannot parse REDO location\n", __LINE__);
+			cluster->controldata.redo_location = (((uint64) hi) << 32) | lo;
+			got_redo_location = true;
+		}
 	}
 
 	pclose(output);
@@ -528,6 +546,13 @@ get_control_data(ClusterInfo *cluster, bool live_check)
 		}
 	}
 
+	/*
+	 * If we used pg_resetwal instead of pg_controldata, there is no REDO
+	 * location.
+	 */
+	if (!got_redo_location)
+		cluster->controldata.redo_location = 0;
+
 	/* verify that we got all the mandatory pg_control data */
 	if (!got_xid || !got_oid ||
 		!got_multi ||
diff --git a/src/bin/pg_upgrade/exec.c b/src/bin/pg_upgrade/exec.c
index 043373f..90de62e 100644
--- a/src/bin/pg_upgrade/exec.c
+++ b/src/bin/pg_upgrade/exec.c
@@ -351,6 +351,10 @@ check_data_dir(ClusterInfo *cluster)
 		check_single_dir(pg_data, "pg_clog");
 	else
 		check_single_dir(pg_data, "pg_xact");
+
+	/* pg_undo is new in v13 */
+	if (GET_MAJOR_VERSION(cluster->major_version) >= 1200)
+		check_single_dir(pg_data, "pg_undo");
 }
 
 
diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
index ff78929..a51da36 100644
--- a/src/bin/pg_upgrade/pg_upgrade.c
+++ b/src/bin/pg_upgrade/pg_upgrade.c
@@ -139,6 +139,8 @@ main(int argc, char **argv)
 
 	/* New now using xids of the old system */
 
+	merge_undo_logs();
+
 	/* -- NEW -- */
 	start_postmaster(&new_cluster, true);
 
diff --git a/src/bin/pg_upgrade/pg_upgrade.h b/src/bin/pg_upgrade/pg_upgrade.h
index 5d31750..d0d93c0 100644
--- a/src/bin/pg_upgrade/pg_upgrade.h
+++ b/src/bin/pg_upgrade/pg_upgrade.h
@@ -227,6 +227,7 @@ typedef struct
 	bool		date_is_int;
 	bool		float8_pass_by_value;
 	bool		data_checksum_version;
+	uint64		redo_location;
 } ControlData;
 
 /*
@@ -465,3 +466,7 @@ void		parallel_transfer_all_new_dbs(DbInfoArr *old_db_arr, DbInfoArr *new_db_arr
 										  char *old_pgdata, char *new_pgdata,
 										  char *old_tablespace);
 bool		reap_child(bool wait_for_child);
+
+/* undo.c */
+
+void		merge_undo_logs(void);
diff --git a/src/bin/pg_upgrade/undo.c b/src/bin/pg_upgrade/undo.c
new file mode 100644
index 0000000..6efc99b
--- /dev/null
+++ b/src/bin/pg_upgrade/undo.c
@@ -0,0 +1,292 @@
+/*
+ *	undo.c
+ *
+ *	Support for upgrading undo logs.\
+ *	Copyright (c) 2019, PostgreSQL Global Development Group
+ *	src/bin/pg_upgrade/undo.c
+ */
+
+
+#include "postgres_fe.h"
+#include "pg_upgrade.h"
+#include "access/undolog.h"
+
+/*
+ * The relevant parts of UndoLogMetaDataData, in a version-independent format.
+ */
+typedef struct
+{
+	UndoLogNumber logno;
+	UndoLogOffset discard;
+	UndoLogStatus status;
+	UndoPersistence persistence;
+	Oid			tablespace;
+} UndoLogInfo;
+
+/*
+ * Read the header of a pg_undo file and extract basic information.  If the
+ * format of the header changes in later versions, this may need to change
+ * depending on "cluster".
+ */
+static void
+read_pg_undo_header(int fd, ClusterInfo *cluster, UndoLogNumber *low_logno,
+					UndoLogNumber *next_logno, UndoLogNumber *num_logs)
+{
+	pg_crc32c crc;
+
+	/* Read the header, much like StartupUndoLogs(). */
+	if (read(fd, low_logno, sizeof(*low_logno)) != sizeof(*low_logno) ||
+		read(fd, next_logno, sizeof(*next_logno)) != sizeof(*next_logno) ||
+		read(fd, num_logs, sizeof(*num_logs)) != sizeof(*num_logs) ||
+		read(fd, &crc, sizeof(crc)) != sizeof(crc))
+		pg_fatal("pg_undo file is corrupted or cannot be read\n");
+}
+
+/*
+ * Read a single UndoLogMetaData object.  If the format changes in later
+ * versions, this may need to change to be able to read different structs
+ * depending on "cluster".
+ */
+static void
+read_one_undo_log(int fd, ClusterInfo *cluster, UndoLogInfo *info)
+{
+	UndoLogMetaData meta_data;
+	int		rc;
+
+	rc = read(fd, &meta_data, sizeof(meta_data));
+	if (rc < 0)
+		pg_fatal("could not read undo log meta-data: %m");
+	else if (rc != sizeof(meta_data))
+		pg_fatal("could not read undo log meta-data: expect %zu bytes but read only %d bytes",
+				 sizeof(meta_data), rc);
+
+	info->logno = meta_data.logno;
+	info->persistence = meta_data.persistence;
+	info->tablespace = meta_data.tablespace;
+	info->discard = meta_data.discard;
+	info->status = meta_data.status;
+}
+
+static void
+merge_undo_log(UndoLogInfo *logs, UndoLogNumber *num_logs,
+			   const UndoLogInfo *info)
+{
+	UndoLogNumber i;
+
+	/* Do we already have an entry for this logno? */
+	for (i = 0; i < *num_logs; ++i)
+	{
+		if (logs[i].logno == info->logno)
+		{
+			/*
+			 * Take the highest discard offset, so that any pointers that
+			 * originated in either cluster appear to be discarded.
+			 */
+			if (logs[i].discard < info->discard)
+				logs[i].discard = info->discard;
+
+			/*
+			 * Take the highest status so that entirely discarded logs trump
+			 * active logs.
+			 */
+			StaticAssertStmt(UNDO_LOG_STATUS_ACTIVE < UNDO_LOG_STATUS_FULL,
+							 "undo log status out of order");
+			StaticAssertStmt(UNDO_LOG_STATUS_FULL < UNDO_LOG_STATUS_DISCARDED,
+							 "undo log status out of order");
+			if (logs[i].status < info->status)
+				logs[i].status = info->status;
+
+			/*
+			 * Take the most persistent persistence level.  While we could
+			 * just convert them all to permanent and it wouldn't hurt, it's
+			 * probably a better idea to keep about the same number of each
+			 * persistence level, so that a system that has stabilized with
+			 * those numbers will continue to be stable after the upgrade (ie
+			 * not suddenly need to create more undo logs of different
+			 * levels).  The most permanent is the best choice, because TEMP
+			 * undo logs might be rewound in future.
+			 */
+			StaticAssertStmt(UNDO_PERMANENT < UNDO_UNLOGGED,
+							 "undo log persistent out of order");
+			StaticAssertStmt(UNDO_UNLOGGED < UNDO_TEMP,
+							 "undo log persistent out of order");
+			if (logs[i].status > info->status)
+				logs[i].status = info->status;
+
+			/*
+			 * Take the highest tablespace OID.  The choice of 'highest' is
+			 * arbitrary (we don't really expect the new cluster to have more
+			 * than one log), but it seems useful to preserve the distribution
+			 * of tablespaces from the old cluster for stability, as above.
+			 */
+			if (logs[i].tablespace < info->tablespace)
+				logs[i].tablespace = info->tablespace;
+			break;
+		}
+	}
+
+	/* Otherwise create a new entry. */
+	logs[*num_logs++] = *info;
+}
+
+/*
+ * We need to merge the old undo logs and the new undo logs.  We know that
+ * there is no live undo data (see check_for_live_undo_data()), but we need to
+ * make sure that any undo record pointers that exist in the old OR new
+ * cluster appear as discarded.  That is, any log numbers that are entirely
+ * discard in either cluster appear as entirely discarded, and and we retain
+ * the higher of the discard pointers in any log that is active.  This is
+ * mostly a theoretical concern for now, but perhaps a future release will be
+ * able to create higher undo record pointers during initdb than the old
+ * cluster had, so let's use an algorithm that doesn't make any assumptions
+ * about that.
+ */
+void
+merge_undo_logs(void)
+{
+	char		old_pg_undo_path[MAXPGPATH];
+	char		new_pg_undo_path[MAXPGPATH];
+	UndoLogInfo *logs;
+	UndoLogNumber num_logs;
+	UndoLogNumber num_old_logs;
+	UndoLogNumber old_low_logno;
+	UndoLogNumber old_next_logno;
+	UndoLogNumber num_new_logs;
+	UndoLogNumber new_low_logno;
+	UndoLogNumber new_next_logno;
+	UndoLogNumber i;
+	int			old_fd;
+	int			new_fd;
+	pg_crc32c	crc;
+
+	/* If the old cluster has no undo logs, there is nothing to do */
+	if (GET_MAJOR_VERSION(old_cluster.major_version) < 1200)
+		return;
+
+	/*
+	 * Open the pg_undo files corresponding to the old and new redo locations.
+	 * First, we'll reload pg_controldata output, so that we have up-to-date
+	 * redo locations.
+	 */
+	get_control_data(&old_cluster, true);
+	get_control_data(&new_cluster, true);
+	snprintf(old_pg_undo_path,
+			 sizeof(old_pg_undo_path),
+			 "%s/pg_undo/%016" INT64_MODIFIER "X",
+			 old_cluster.pgdata,
+			 old_cluster.controldata.redo_location);
+	snprintf(new_pg_undo_path,
+			 sizeof(new_pg_undo_path),
+			 "%s/pg_undo/%016" INT64_MODIFIER "X",
+			 new_cluster.pgdata,
+			 new_cluster.controldata.redo_location);
+	old_fd = open(old_pg_undo_path, O_RDONLY, 0);
+	if (old_fd < 0)
+		pg_fatal("could not open file \"%s\": %m\n", old_pg_undo_path);
+	new_fd = open(new_pg_undo_path, O_RDWR, 0);
+	if (new_fd < 0)
+		pg_fatal("could not open file \"%s\": %m\n", new_pg_undo_path);
+
+	/* Read the headers */
+	read_pg_undo_header(old_fd, &old_cluster, &old_low_logno, &old_next_logno, &num_old_logs);
+	read_pg_undo_header(new_fd, &new_cluster, &new_low_logno, &new_next_logno, &num_new_logs);
+
+	/* Allocate workspace that is sure to be enough for the merged set */
+	logs = malloc(sizeof(*logs) * (num_old_logs + num_new_logs));
+	if (logs == NULL)
+	{
+		pg_fatal("out of memory\n");
+		exit(1);
+	}
+	num_logs = 0;
+
+	/*
+	 * Anything below the "low" logno has been entirely discarded, so we'll
+	 * take the higher of the two values.  Likewise, the "next" log number to
+	 * allocate should be the higher of the two.
+	 */
+	new_low_logno = Max(old_low_logno, new_low_logno);
+	new_next_logno = Max(old_next_logno, new_next_logno);
+
+	/* Merge in the old logs */
+	while (num_old_logs > 0)
+	{
+		UndoLogInfo	info;
+
+		read_one_undo_log(old_fd, &old_cluster, &info);
+		merge_undo_log(logs, &num_logs, &info);
+		--num_old_logs;
+	}
+
+	/* Merge in the new logs */
+	while (num_new_logs > 0)
+	{
+		UndoLogInfo	info;
+
+		read_one_undo_log(new_fd, &old_cluster, &info);
+		merge_undo_log(logs, &num_logs, &info);
+		--num_new_logs;
+	}
+
+	close(old_fd);
+
+	/* Now write out the new file, much like CheckPointUndoLogs() */
+	if (ftruncate(new_fd, 0) < 0)
+		pg_fatal("could not truncate file \"%s\": %m", new_pg_undo_path);
+	if (lseek(new_fd, SEEK_SET, 0) < 0)
+		pg_fatal("could not seek to start of file \"%s\": %m", new_pg_undo_path);
+
+	/* Compute header checksum */
+	INIT_CRC32C(crc);
+	COMP_CRC32C(crc, &new_low_logno, sizeof(new_low_logno));
+	COMP_CRC32C(crc, &new_next_logno, sizeof(new_next_logno));
+	COMP_CRC32C(crc, &num_logs, sizeof(num_logs));
+	FIN_CRC32C(crc);
+
+	/* Write out the header */
+	if ((write(new_fd, &new_low_logno, sizeof(new_low_logno)) != sizeof(new_low_logno)) ||
+		(write(new_fd, &new_next_logno, sizeof(new_next_logno)) != sizeof(new_next_logno)) ||
+		(write(new_fd, &num_logs, sizeof(num_logs)) != sizeof(num_logs)) ||
+		(write(new_fd, &crc, sizeof(crc)) != sizeof(crc)))
+		pg_fatal("could not write to file \"%s\": %m", new_pg_undo_path);
+
+	/* Write out the undo logs */
+	INIT_CRC32C(crc);
+	for (i = 0; i < num_logs; ++i)
+	{
+		UndoLogMetaData	meta_data;
+		UndoLogInfo	*info = &logs[i];
+		UndoLogOffset end;
+
+		memset(&meta_data, 0, sizeof(meta_data));
+		meta_data.logno = info->logno;
+
+		/*
+		 * Round the discard offset up so that it points to the first byte in
+		 * a segment, and assign that to all three offsets.  That means there
+		 * is no logical data, and there are no physical files.
+		 */
+		end = ((info->discard + UndoLogSegmentSize - 1) / UndoLogSegmentSize)
+			* UndoLogSegmentSize;
+		meta_data.unlogged.insert = meta_data.discard = meta_data.end = end;
+
+		/*
+		 * We have whatever was the highest status (though it probably
+		 * wouldn't hurt if we set them all to ACTIVE).
+		 */
+		meta_data.status = info->status;
+
+
+		if (write(new_fd, &meta_data, sizeof(meta_data)) != sizeof(meta_data))
+			pg_fatal("could not write to file \"%s\": %m", new_pg_undo_path);
+
+		COMP_CRC32C(crc, &meta_data, sizeof(meta_data));
+	}
+	FIN_CRC32C(crc);
+
+	if (write(new_fd, &crc, sizeof(crc)) != sizeof(crc))
+		pg_fatal("could not write to file \"%s\": %m", new_pg_undo_path);
+
+	close(new_fd);
+	free(logs);
+}
diff --git a/src/bin/pg_waldump/rmgrdesc.c b/src/bin/pg_waldump/rmgrdesc.c
index 852d8ca..938150d 100644
--- a/src/bin/pg_waldump/rmgrdesc.c
+++ b/src/bin/pg_waldump/rmgrdesc.c
@@ -20,6 +20,7 @@
 #include "access/nbtxlog.h"
 #include "access/rmgr.h"
 #include "access/spgxlog.h"
+#include "access/undolog_xlog.h"
 #include "access/xact.h"
 #include "access/xlog_internal.h"
 #include "catalog/storage_xlog.h"
diff --git a/src/include/access/rmgrlist.h b/src/include/access/rmgrlist.h
index 3c0db2c..6945e3e 100644
--- a/src/include/access/rmgrlist.h
+++ b/src/include/access/rmgrlist.h
@@ -47,3 +47,4 @@ PG_RMGR(RM_COMMIT_TS_ID, "CommitTs", commit_ts_redo, commit_ts_desc, commit_ts_i
 PG_RMGR(RM_REPLORIGIN_ID, "ReplicationOrigin", replorigin_redo, replorigin_desc, replorigin_identify, NULL, NULL, NULL)
 PG_RMGR(RM_GENERIC_ID, "Generic", generic_redo, generic_desc, generic_identify, NULL, NULL, generic_mask)
 PG_RMGR(RM_LOGICALMSG_ID, "LogicalMessage", logicalmsg_redo, logicalmsg_desc, logicalmsg_identify, NULL, NULL, NULL)
+PG_RMGR(RM_UNDOLOG_ID, "UndoLog", undolog_redo, undolog_desc, undolog_identify, NULL, NULL, NULL)
diff --git a/src/include/access/session.h b/src/include/access/session.h
index 8fba568..650b181 100644
--- a/src/include/access/session.h
+++ b/src/include/access/session.h
@@ -17,6 +17,9 @@
 /* Avoid including typcache.h */
 struct SharedRecordTypmodRegistry;
 
+/* Avoid including undolog.h */
+struct UndoLogSlot;
+
 /*
  * A struct encapsulating some elements of a user's session.  For now this
  * manages state that applies to parallel query, but it principle it could
@@ -27,6 +30,10 @@ typedef struct Session
 	dsm_segment *segment;		/* The session-scoped DSM segment. */
 	dsa_area   *area;			/* The session-scoped DSA area. */
 
+	/* State managed by undolog.c. */
+	struct UndoLogSlot *attached_undo_slots[3];
+	bool		need_to_choose_undo_tablespace;
+
 	/* State managed by typcache.c. */
 	struct SharedRecordTypmodRegistry *shared_typmod_registry;
 	dshash_table *shared_record_table;
